unit ShellTree_Unit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ShellTree, ComCtrls, StdCtrls, ShellTreeTypes, ShellTreeProcs, SHLOBJ,
  ExtCtrls;

type
  TForm1 = class(TForm)
    DirectoryLabel: TPanel;
    Label1: TLabel;
    Directory: TEdit;
    GroupBox1: TGroupBox;
    RootUsePidl: TCheckBox;
    SetRootDir: TButton;
    RootDir: TEdit;
    PidlRoot: TRadioGroup;
    Quit: TButton;
    ShellTree1: TShellTree;
    Options: TGroupBox;
    CB_TF_NONFOLDERS: TCheckBox;
    CB_TF_HIDDEN: TCheckBox;
    CB_TF_FOLDERS: TCheckBox;
    procedure FormShow(Sender: TObject);
    procedure ShellTree1Change(Sender: TObject; Node: TTreeNode);
    procedure PidlRootClick(Sender: TObject);
    procedure QuitClick(Sender: TObject);
    procedure RootUsePidlClick(Sender: TObject);
    procedure SetRootDirClick(Sender: TObject);
    procedure RootDirKeyPress(Sender: TObject; var Key: Char);
    procedure DirectoryKeyPress(Sender: TObject; var Key: Char);
    procedure CB_TF_FOLDERSClick(Sender: TObject);
    procedure CB_TF_NONFOLDERSClick(Sender: TObject);
    procedure CB_TF_HIDDENClick(Sender: TObject);
  private
    { Private declarations }
  protected
  public
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormShow(Sender: TObject);
Var
  B : Boolean;
begin
  RootUsePidl.Checked:=Shelltree1.RootUsePidl;
  RootDir.Text:=ShellTree1.RootDir;
  CB_TF_FOLDERS.Checked   :=(TF_FOLDERS in Shelltree1.Options);
  CB_TF_NONFOLDERS.Checked:=(TF_NONFOLDERS in Shelltree1.Options);
  CB_TF_HIDDEN.Checked    :=(TF_HIDDEN in Shelltree1.Options);
end;

procedure TForm1.ShellTree1Change(Sender: TObject; Node: TTreeNode);
begin
  DirectoryLabel.Caption:=ShellTree1.Directory;
  Directory.Text:=DirectoryLabel.Caption;
end;

procedure TForm1.PidlRootClick(Sender: TObject);
Var
  T : TPidls;
begin
  Case PidlRoot.ItemIndex OF
    0  : T:=PIDL_BITBUCKET;
    1  : T:=PIDL_CONTROLS;
    2  : T:=PIDL_DESKTOP;
    3  : T:=PIDL_DESKTOPDIRECTORY;
    4  : T:=PIDL_DRIVES;
    5  : T:=PIDL_FONTS;
    6  : T:=PIDL_NETHOOD;
    7  : T:=PIDL_NETWORK;
    8  : T:=PIDL_PERSONAL;
    9  : T:=PIDL_PRINTERS;
    10 : T:=PIDL_PROGRAMS;
    11 : T:=PIDL_RECENT;
    12 : T:=PIDL_SENDTO;
    13 : T:=PIDL_STARTMENU;
    14 : T:=PIDL_STARTUP;
    15 : T:=PIDL_TEMPLATES;
    16 : T:=PIDL_FAVORITES
  end;
  ShellTree1.RootPIDL:=T;
end;

procedure TForm1.QuitClick(Sender: TObject);
begin
  Close;
end;

procedure TForm1.RootUsePidlClick(Sender: TObject);
begin
  Shelltree1.RootUsePidl:=RootUsePidl.Checked;
end;

procedure TForm1.SetRootDirClick(Sender: TObject);
begin
  ShellTree1.RootDir:=RootDir.Text;
  RootDir.Text:=ShellTree1.RootDir;
end;

procedure TForm1.RootDirKeyPress(Sender: TObject; var Key: Char);
begin
  IF Key=#13 Then begin
    SetRootDirClick(Sender);
    Key:=#0;
  end;
end;

procedure TForm1.DirectoryKeyPress(Sender: TObject; var Key: Char);
begin
  IF Key=#13 Then begin
    ShellTree1.Directory:=Directory.Text;
    Key:=#0;
    Directory.Text:=ShellTree1.Directory;
  end;
end;





procedure TForm1.CB_TF_FOLDERSClick(Sender: TObject);
begin
  IF CB_TF_Folders.Checked Then
    ShellTree1.Options:=ShellTree1.Options+[TF_FOLDERS]
  else
    ShellTree1.Options:=ShellTree1.Options-[TF_FOLDERS];
end;

procedure TForm1.CB_TF_NONFOLDERSClick(Sender: TObject);
begin
  IF CB_TF_NONFolders.Checked Then
    ShellTree1.Options:=ShellTree1.Options+[TF_NONFOLDERS]
  else
    ShellTree1.Options:=ShellTree1.Options-[TF_NONFOLDERS];
end;

procedure TForm1.CB_TF_HIDDENClick(Sender: TObject);
begin
  IF CB_TF_Hidden.Checked Then
    ShellTree1.Options:=ShellTree1.Options+[TF_Hidden]
  else
    ShellTree1.Options:=ShellTree1.Options-[TF_Hidden];
end;

end.
